/**
 * Copyright (C) 2015 Christian Wulf, Nelson Tavares de Sousa (http://christianwulf.github.io/teetime)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package teetime.framework;

public class ThreadService {

	public Runnable startWithinNewThread(final Stage stage) {
		Runnable runnable = wrap(stage);
		Thread thread = new Thread(runnable);
		thread.start();
		return runnable;
	}

	private AbstractRunnableStage wrap(final Stage stage) {
		if (stage.getInputPorts().size() > 0) {
			return new RunnableConsumerStage(stage);
		}
		return new RunnableProducerStage(stage);
	}
}
